package ch.zhaw.projekt2.turnierverwaltung;


import java.io.File;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.util.Arrays;
import java.util.List;


public class FileIO {
    private File mainDir;
    private File saves;


    public FileIO(String saveLocation) {
        this.mainDir = new File(saveLocation);
        mainDir.mkdir();
        saves = new File(mainDir, "saves");
        saves.mkdir();
    }

    public List<File> getList() {
        return Arrays.asList(saves.listFiles());
    }

    public Tournament loadTournament(File tournamentFile) {
        Tournament tournament;
        try {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(tournamentFile));
            tournament = (Tournament) in.readObject();
            in.close();
            System.out.println("Save File" + tournament.getName() + ".txt being saved to " + saves.getAbsolutePath());

        } catch (ClassNotFoundException | IOException e) {
            throw new RuntimeException(e);
        }

        return tournament;
    }

    public void saveTournament(Tournament tournament) {
        File newSave = new File(saves, tournament.getName() + ".txt");
        try {
            newSave.createNewFile();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(newSave));
            out.writeObject(tournament);
            out.close();
            System.out.println("Save File" + tournament.getName() + ".txt being saved to " + saves.getAbsolutePath());

        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
